import dash
from dash import html
from dash import dcc
import dash_bootstrap_components as dbc
from dash.dependencies import Input, Output, State
from dash.exceptions import PreventUpdate
import pymongo
import shutil
from app import app #import the initialized app.py
from app import server #initialized server in the app.py

import evaluate,register_new,login,payment,profile_1
import user

# Connect to MongoDB
client = pymongo.MongoClient("mongodb+srv://admin:admin@cluster0.afxihmt.mongodb.net/")
db = client["user_database"]
users_collection = db["users"]
user1 = user.User("","") #create a new instance of a user object,
history_collection = db["history"]
                                              #update the data property, with an id of signout-value
@app.callback(Output('signout-value', 'data'), #decorates a Python function as a Dash callback.
              Input('signout', 'n_clicks'))  #callback triggered when signout is pressed
def signout(n_clicks):
    if n_clicks is None: #to prevent the callback from executing if it was not triggered by a user interaction
        raise PreventUpdate
    return "False"        #If n_clicks is not None, it returns the string "False."

header = html.Div([ #defines a header variable as an instance of the html.Div component. 
    dbc.Row([ #provides pre-styled components for building web applications with Dash.
        # html.Img(src=app.get_asset_url('logo.jpg'), id='logo', style ,height='100px'),
        dbc.Nav(
    [                                    #creates a navigation item containing an image 
        dbc.NavItem(html.Img(src=app.get_asset_url('logo.png'), id='logo', height='100px', style={'padding':'10px'})),
        dbc.NavItem(dbc.NavLink(html.H1("SpinPerform"),id='logo-text', active=True, href="/")), #links to the root
        # dbc.NavItem(dbc.NavLink("A link", href="#")),         #creates another navigation item containing a hyperlink 
        # dbc.NavItem(dbc.NavLink("Another link", href="#")),
        # dbc.NavItem(dbc.NavLink("Disabled", disabled=True, href="#")),
        html.Div(id='nav_home', children=[],style={'margin-left':'auto','padding':'10px','display':'flex','align-items':'center','justify-content':'center'}),
                                       #an empty html.Div element with an ID of 'nav_home'.
    ],style={'textAlign':'center'}
)
    ],style={'display':'flex','align-items':'center','justify-content':'center','padding':'10px'}),
    
], className='header_box')

container = html.Div([ #html.Div is used to create a container for the content of the section.
    html.Div([
        html.Div([ #inner html.Div is used to group the content of this section together.
            html.H1('Boost your skills with new technologies..', className='title'),
            html.Div([ #heading name
                dbc.Button('Evaluate', className='btn-started', href='/Evaluate'), #Evaluate button
                # dbc.Button('Learn More', color='primary', className='btn-started', href='/about'),
            ], className='line'),
        ], className='main-container-word-box'),
        html.Img(src=app.get_asset_url('p3.png'), id='main-vector')  #displaying an image
    ], className='main-container-box'),
], className='container-fluid')
app.layout = html.Div( #sets the layout of the Dash application using an html.Div element as the root container.
    [
        # dcc.Input(id='logger_store',value="False", type='hidden'),
        dcc.Store(id='intermediate-value'), #creates a Dash Core Component 
        dcc.Store(id='signout-value'), #to store and share data between different parts of the application.
        dcc.Location(id='url', refresh=False), #to track and update the URL of the application.
        header,               #allows the application to respond to changes in the URL.
        dcc.Loading(type='default', id='loading-1', children=[ #provides a loading message while the content inside it is being loaded or updated.
            html.Div(id='page_content', children=[]),
        ]),
    ], className='container-fluid'
)
# @app.callback(Output('nav_home', 'children'),[Input("intermediate-value", "data"),Input("signout-value", "data")])
# def logger_checker(logger,sign):
#     print("logger_checker",logger)
#     print("sign",sign)
#     if not logger == 'False' and  logger is not None:
#         if not sign == "False":
#             return [
#                 # dbc.Button("Sign Out" ,id="signout" , className="mr-1", href='/signout'),
#                 html.Div(id='img-circle', children=[],style={'padding':'10px','background':'url(https://www.w3schools.com/howto/img_avatar.png) center / cover','width':'50px','height':'50px','border-radius':'50%','margin-right':'10px'}),
#                 # html.Img(src=app.get_asset_url('user.webp'),id='user', height='80px', style={'padding':'10px'},className="img-circle"),
#                 dbc.DropdownMenu(
#                     children=[
#                         dbc.DropdownMenuItem(logger, header=True),
#                         dbc.DropdownMenuItem("Profile", href="/profile",id="profile"),
#                         dbc.DropdownMenuItem("Signout", href="/signout",id="signout"),
#                     ],
#                     nav=True,
#                     in_navbar=True,
#                     # label=html.Img(src=app.get_asset_url('user.jpg'),id='user', height='30px', style={'padding':'10px'},className="img-circle"),
#                 ),
#                 # dbc.Button("Sign In" ,id="signin" , className="mr-1", href='/signin'),
#                 # dbc.Button("Sign Up", color="primary", id="signup",className="mr-1", href='/signup'),
#             ]
#     else:
#         return [
#             dbc.Button("Sign In" ,id="signin" , className="mr-1", href='/signin'),
#             dbc.Button("Sign Up", color="primary", id="signup",className="mr-1", href='/signup'),
#         ]
# Define callback to handle registration                 #pdate the content (children) of an element
@app.callback( #will update the "pathname" property of an element #will update the "data" property of an element
    [Output("url", "pathname"),Output('intermediate-value', 'data'),Output('register-status', 'children')],
    [Input("register-button", "n_clicks"),Input('logger_store', 'value')], #callbac triggers when the button pressed
    State("username-input", "value"),#cqptures the value of the input when the callbavk triggers
    State("password-input", "value"),
)                           #logger type ("reg"), #string representing the username entered during registration.
def register_user(n_clicks,logger, username, password):
    if n_clicks is None: #if notclicked by the user, prevent callback from executing
        raise PreventUpdate
    else: #it proceeds to the registration logic.
        if logger == "reg":
            if not username or not password: #if either is not there
                return "/signup","False","Username and password are required."
            # Check if the username already exists
            existing_user = users_collection.find_one({"username": username})
            if existing_user:
                return  "/signup","False","Username already exists."

            # Insert new user into the database
            new_user = {
                "username": username,
                "password": password
            }
            users_collection.insert_one(new_user)
            # print("User in fo ----------------",new_user)
            # user1 = user.User(username,password)
            # user1.log_in()
            # print("User in fo ----------------",user1.get_user_info())
            return  "/",username,"Registration successful."
        else:
            if not username or not password:
                    return "/signin","False","Username and password are required."

            # Check if the user exists and the password matches
            user = users_collection.find_one({"username": username})
            if user and user["password"] == password: #if the username & pw is correctly given
                return "/",username,"Login successful."
            else:
                return "/signin","False","Invalid username or password."

# Define callback to handle login
# @app.callback(
#     [Output("url", "pathname"),Output('intermediate-value', 'data'),Output('login-status', 'children')],
#     Input("login-button", "n_clicks"),
#     State("login-username-input", "value"),
#     State("login-password-input", "value")
# )
# def login_user(n_clicks, username, password):
#     if n_clicks is None:
#         raise PreventUpdate

#     if not username or not password:
#         return "/signin","False","Username and password are required."

#     # Check if the user exists and the password matches
#     user = users_collection.find_one({"username": username})
#     if user and user["password"] == password:
#         return "/","True","Login successful."
#     else:
#         return "/signin","False","Invalid username or password."



#updates the "children" property of an element with the ID "page_content." (update main content)
@app.callback([Output(component_id='page_content', component_property='children'),Output('nav_home', 'children')],
              [Input(component_id='url', component_property='pathname'),Input("intermediate-value", "data"),Input("signout-value", "data")])
def load_content(pathname,logger,sign): #captures changes in the URL path name
    print("logger",logger)
    print("sign",sign) #dispay the values of the variables
    val = []
    if not logger == 'False' and  logger is not None: #check if the variable are empty
        if not sign == "False":
            val =  [
                # dbc.Button("Sign Out" ,id="signout" , className="mr-1", href='/signout'),
                html.Div(id='img-circle', children=[],style={'padding':'10px','background':'url(https://www.w3schools.com/howto/img_avatar.png) center / cover','width':'50px','height':'50px','border-radius':'50%','margin-right':'10px'}),
                # html.Img(src=app.get_asset_url('user.webp'),id='user', height='80px', style={'padding':'10px'},className="img-circle"),
                dbc.DropdownMenu(
                    children=[
                        dbc.DropdownMenuItem(logger, header=True), #user's name
                        dbc.DropdownMenuItem("Profile", href="/profile",id="profile"), #profile link
                        dbc.DropdownMenuItem("Signout", href="/signout",id="signout"), #signout link
                    ],
                    nav=True,
                    in_navbar=True,
                    # label=html.Img(src=app.get_asset_url('user.jpg'),id='user', height='30px', style={'padding':'10px'},className="img-circle"),
                ),
                # dbc.Button("Sign In" ,id="signin" , className="mr-1", href='/signin'),
                # dbc.Button("Sign Up", color="primary", id="signup",className="mr-1", href='/signup'),
            ]
        else:
            val = [ #buttons to sign in and sign up
                dbc.Button("Sign In" ,id="signin" , className="mr-1", href='/signin'),
                dbc.Button("Sign Up", color="primary", id="signup",className="mr-1", href='/signup'),
            ]
    else:
        val = [
            dbc.Button("Sign In" ,id="signin" , className="mr-1", href='/signin'),
            dbc.Button("Sign Up", color="primary", id="signup",className="mr-1", href='/signup'),
        ]
    if not logger == 'False' and not logger == None:
        if not sign == "False":
            if pathname == '/':
                return container,val
            elif pathname == '/Evaluate':
                return evaluate.outer_box,val
            elif pathname == '/signup':
                return register_new.reg,val
            elif pathname == '/signin':
                return register_new.log,val
            elif pathname == '/signout':
                return register_new.log,val
            elif pathname == '/app/danger_area':
                return None,val
            elif pathname == '/app/no_ball':
                return None,val
            elif pathname == '/app/arm_angle':
                return None,val
            elif pathname == '/app/leg_angle':
                return None,val
            elif pathname == '/profile':
                return profile_1.prof,val
            elif pathname == '/payment':
                return payment.payment,val
            else:
                return ["404 Error"],val
        else:
            if pathname == '/signup':
                return register_new.reg,val
            elif pathname == '/signin':
                return register_new.log,val
            else:
                return register_new.log,val
    else:
        if pathname == '/signup':
            return register_new.reg,val
        elif pathname == '/signin':
            return register_new.log,val
        else:
            return register_new.log,val
                          #calling the main function from flask
if __name__ == "__main__": #checks whether the script is being executed as the main program
    app.run_server(debug = False) #not in the debug mode