import dash
from dash import html, dcc, Input, Output, State
from dash.exceptions import PreventUpdate
import pymongo
import dash_bootstrap_components as dbc
from app import app
# Define the layout of the login page
#defines the layout of a web page for a login form with some styling using HTML and Dash components
log = html.Div([ #Dash HTML component used to create a div element in the web page's structure
    html.Div([ # there are two main sections:
        html.H1("Login"), #main title of the login form
        html.Div([ #used to contain the login form elements
            html.Div([
                html.Label("Email address"),#label
                dcc.Input(id="login-username-input",type="email",className="form-control",placeholder="Enter email"),
            ],className="login-inner-box-input"), #inputing the username
            html.Div([html.Label("Password"), #inputing the password
            dcc.Input(id="login-password-input", type="password",className="form-control",placeholder="Password")],className="login-inner-box-input"),
            
            html.Center([dbc.Button("Login",className="btn btn-light", id="login-button")]) , #login button
            html.Div(id="login-status")
        ])
    ],className="card login-inner-box"),
    html.Img(src=app.get_asset_url('login.gif'),id="login-vector") #display an image on the web page
    
],className="login-outer-box")

